#ifndef BSON2KSATCLAUSE_CONVERTER_H
#define BSON2KSATCLAUSE_CONVERTER_H

#include "util/convert.h"
#include "util/ksatinstance.h"

#include "bsoncxx/document/view.hpp"
#include "bsoncxx/array/view.hpp"
#include "bsoncxx/document/element.hpp"
#include "bsoncxx/types.hpp"

namespace satlab
{

namespace types
{
    
template<typename = KSATinstance::CLAUSE, typename = bsoncxx::array::element>
void convert(KSATinstance::CLAUSE& clause, const bsoncxx::array::element& docView)
{
    clause = KSATinstance::CLAUSE();
    
    for(auto lit : static_cast<bsoncxx::array::view>(docView.get_array()))
    {
        clause.push_back(lit.get_int32());
    }
}

}

}

#endif // BSON2KSATCLAUSE_CONVERTER_H
