#include "util/experimentscope.h"

namespace satlab
{

KSATinstance* ExperimentScope::InstanceIncrementer::operator->()
{
    return &instance;
}


KSATinstance& ExperimentScope::InstanceIncrementer::operator*()
{
    return instance;
}


void ExperimentScope::InstanceIncrementer::next()
{
    step++;
}


bool ExperimentScope::iterator::operator==(const ExperimentScope::iterator& other)
{
    return cmp(pIncr, other.pIncr);
}


bool ExperimentScope::iterator::operator!=(const ExperimentScope::iterator& other)
{
    return !(cmp(pIncr, other.pIncr));
}

ExperimentScope::iterator::reference ExperimentScope::iterator::operator*()
{
    return (*pIncr).operator*();
}

ExperimentScope::iterator::pointer ExperimentScope::iterator::operator->()
{
    return (*pIncr).operator->();
}

ExperimentScope::iterator& ExperimentScope::iterator::operator++()
{
    pIncr->next();
    
    return *this;
}

ExperimentScope::iterator ExperimentScope::iterator::operator++(int)
{
    iterator copy(*this);
    
    pIncr->next();
    
    return copy;
}

ExperimentScope::iterator::iterator(ExperimentScope::P_INCR_T&& pIncr,
                                    ExperimentScope::iterator::CMP_FNC_T&& cmp)
:   cmp(std::move(cmp)),
    pIncr(std::move(pIncr))
{
}

ExperimentScope::iterator
ExperimentScope::createIterator(ExperimentScope::P_INCR_T&& pIncr, 
                                ExperimentScope::iterator::CMP_FNC_T&& cmp)
{
    return iterator(std::move(pIncr), std::move(cmp));
}


}
